

#include <gtk/gtk.h>
#include <gio/gio.h>

#include <glib/gprintf.h>

#include "file.h"

enum {
	BUFFSIZE = 1024,
};

gchar buff[BUFFSIZE];

int
main(int argc, char *argv[])
{
	g_type_init();

	uic_file *ch = NULL;
	gint res;


	ch = uic_file_open("./lalala.txt", "w+");
	if (ch == NULL) {
		g_printf("%s\n", uic_get_error());
		uic_clear_error();
		return 1;
	}

	if ((res = uic_file_write(ch, "LOLTEST\nLALALA^_^", 17)) < 0) {	
		g_printf("%s\n", uic_get_error());
		uic_clear_error();
	}
	g_printf("bytes writed=%d\n", res);
	
	if (uic_file_seek(ch, 0, G_SEEK_SET) != 0) {
		g_printf("%s\n", uic_get_error());
		uic_clear_error();
	}

	if ((res = uic_file_read(ch, buff, sizeof(buff) - 1)) < 0) {
		g_printf("%d:%s\n",uic_errnum, uic_get_error());
		uic_clear_error();
	}
	g_printf("bytes readed=%d\n", res);

	buff[res] = '\0';
	g_printf("%s\n", buff);
	

	if (uic_file_seek(ch, 20, G_SEEK_END) != 0) {
		g_printf("%s\n", uic_get_error());
		uic_clear_error();
	}

	if ((res = uic_file_read(ch, buff, sizeof(buff) - 1)) < 0) {
		g_printf("%d:%s\n",uic_errnum, uic_get_error());
		uic_clear_error();
	}
	g_printf("bytes readed=%d\n", res);

	if (uic_file_close(ch) != 0) {
		g_printf("%s\n", uic_get_error());
		uic_clear_error();
		return 1;
	}
	
	ch = uic_file_open("./img.jpg", "r");
	if (ch == NULL) {
		g_printf("%s\n", uic_get_error());
		uic_clear_error();
		return 1;
	} else
		g_print("img.jpg opened!\n");
	
	if ((res = uic_file_read(ch, buff, sizeof(buff) - 1)) < 0) {
		g_printf("%d:%s\n",uic_errnum, uic_get_error());
		uic_clear_error();
	}
	g_printf("bytes readed=%d %s\n", res, uic_get_error());

	if (uic_file_seek(ch, 1, G_SEEK_END) != 0) {
		g_printf("%s\n", uic_get_error());
		uic_clear_error();
	}
	
	struct uic_file_st st;

	if (uic_file_stat("lalala.txt", &st) != 0) {
		g_printf("uic_file_stat:%s\n", uic_get_error());
		uic_clear_error();
	} else
		g_printf("sizeof = %d\n create time = %d\n", (guint)st.size, (guint)st.ctime);


	if ((res = uic_file_read(ch, buff, sizeof(buff) - 1)) < 0) {
		g_printf("%d:%s\n",uic_errnum, uic_get_error());
		uic_clear_error();
	}
	g_printf("bytes readed=%d\n", res);

	if (uic_file_close(ch) != 0) {
		g_printf("%s\n", uic_get_error());
		uic_clear_error();
		return 1;
	}

	return 0;
}

